#!/usr/bin/env node

/**
 * This is an example of rfunc client
 */
'use strict'

const apemanApi = require('apeman-api-client')
const co = require('co')

co(function * () {
  let api = apemanApi('http://myapp.example.com')
  
  let sign = yield api.connect('sign') // Define a client

  // Call remote api and receive the result
  let { success } = yield sign.signin('foo', 'bar1234')
  console.log('success:', success)

  {
    // Access to scoped api
    let admin = api.of('@admin')
    let user = admin.user()
    yield user.destroy(1)
    /* ... */
  }
}).catch((err) => console.error(err))
