/**
 *  @class ApClient
 */
'use strict'

const { RFuncClient } = require('rfunc-client')
const { spinalcase } = require('stringcase')
const reachMix = require('./mixins/reach_mix')
const eventMix = require('./mixins/event_mix')

let BaseClass = [
  eventMix,
  reachMix
].reduce((BaseClass, mix) => mix(BaseClass), RFuncClient)

/** @lends ApClient */
class ApClient extends BaseClass {
  /**
   * Get scoped client
   */
  of (scope) {
    const s = this
    let pathname = spinalcase(scope.replace(/^@/, ''))
    return new ApClient(s.resolve('scoped', pathname))
  }

}

module.exports = ApClient
