/**
 * @function eventSource
 */
'use strict'

const EventSource = require('eventsource')

/** @lends eventSource */
function eventSource (url, listeners = {}) {
  let instance = new EventSource(url)
  Object.assign(instance, {})
  for (let event of Object.keys(listeners)) {
    let listener = listeners[ event ]
    instance.addEventListener(event, listener)
  }
  return instance
}

module.exports = eventSource
