'use strict'

const load = require('rfunc-client/load')
const co = require('co')
const loadWrap = (...args) => load(...args)

module.exports = Object.assign(loadWrap, {
  load,
  all (modules, options = {}) {
    let loaded = {}
    return co(function * () {
      for (let name of Object.keys(modules)) {
        let module = modules[ name ]
        loaded[ name ] = yield load(module, options)
      }
      return loaded
    })
  }
})
