/**
 * Mix event methods
 * @function eventMix
 * @param {Object} Class
 * @returns {Object} MixedClass
 */
'use strict'

const eventSource = require('../events/event_source')

/** @lends eventMix */
function eventMix (Class) {
  return class EventMixed extends Class {
    /**
     * Access to event source
     * @param {string} moduleName - Name of module
     * @param {string} methodName - Name of method
     * @returns {EventSource}
     */
    eventSource (moduleName, methodName = 'default') {
      const s = this
      let url = s.resolve(moduleName, methodName)
      return eventSource(url)
    }
  }
}

module.exports = eventMix
