'use strict'

const SSEClient = require('sse/lib/sseclient')
const co = require('co')

module.exports = {
  $api: {
    sign: {
      signin () {
        return { success: true }
      },
      $spec: {
        signin: {
          desc: 'Sign in to the application'
        }
      }
    },
    hogeHoge: {
      sayHey () {
        return 'hey'
      }
    },
    sse: {
      default () {
        const s = this
        let { req, res } = s
        let client = new SSEClient(req, res)
        client.initialize()
        return co(function * () {
          let count = 10
          while (count > 0) {
            client.send('tick', JSON.stringify({ count }))
            count--
          }
          client.close()
        })
      }
    },
    '@admin': {
      user: {
        destroy () {
          return { success: false }
        }
      }
    },
    $pathname: '/api/rpc'
  }
}
